      subroutine waveseta(multid,cwav,awave,akapd,ag,arlam,apl,nlam
     1     ,MXLAM)
c     
c     brilliant method for handling wavelength loop arrays
c     
c     file created: 2003/12/23, created from waveset.f (baw)
c     read in analytic scattering properties for each wavelength.
c     
c     history:
c     
c     
      implicit none
      
      integer MXLAM,nlam,i,multid,j
      character cwav(MXLAM)*(*)
      real*8 akapd(MXLAM,4),ag(MXLAM,4),arlam(MXLAM,4),apl(MXLAM,4),
     1     awave(MXLAM)
      character*4 junk

      print*,'in waveseta, using analytic dust properties'
      print*,'multid',multid

      if (multid.eq.1) then

         open(unit=55,file='wavediskmid_analy.in',status='old')
         read(55,*) junk
         
         i=1
 010     read(55,*,end=100) cwav(i),awave(i),akapd(i,1),arlam(i,1)
     1        ,ag(i,1),apl(i,1)
         print*,cwav(i),awave(i),akapd(i,1),arlam(i,1)
     1        ,ag(i,1),apl(i,1)
         i = i + 1
         goto 010
 100     nlam = i-1
         
         close(55)
         
         open(unit=55,file='wavediskup_analy.in',status='old')
         read(55,*) junk
         
         i=1
 020     read(55,*,end=200) cwav(i),awave(i),akapd(i,2),arlam(i,2)
     1        ,ag(i,2),apl(i,2)
         print*,cwav(i),awave(i),akapd(i,2),arlam(i,2)
     1        ,ag(i,2),apl(i,2)
         i = i + 1
         goto 020
 200     nlam = i-1
         
         close(55)
         
         open(unit=55,file='waveenv_analy.in',status='old')
         read(55,*) junk
         
         i=1
 030     read(55,*,end=300) cwav(i),awave(i),akapd(i,3),arlam(i,3)
     1        ,ag(i,3),apl(i,3)
         print*,cwav(i),awave(i),akapd(i,3),arlam(i,3)
     1        ,ag(i,3),apl(i,3)
         i = i + 1
         goto 030
 300     nlam = i-1
         
         close(55)
         
         open(unit=55,file='waveoutflow_analy.in',status='old')
         read(55,*) junk
         
         i=1
 040     read(55,*,end=400) cwav(i),awave(i),akapd(i,4),arlam(i,4),
     1        ag(i,4),apl(i,4)
         print*,cwav(i),awave(i),akapd(i,4),arlam(i,4),
     1        ag(i,4),apl(i,4)
         i = i + 1
         goto 040
 400     nlam = i-1
      
         close(55)

      else
         
         open(unit=55,file='wave_analy.in',status='old')
         read(55,*) junk
         
         i=1
 050     read(55,*,end=500) cwav(i),awave(i),akapd(i,1),arlam(i,1)
     1        ,ag(i,1),apl(i,1)
         print*,cwav(i),awave(i),akapd(i,1),arlam(i,1)
     1        ,ag(i,1),apl(i,1)
         do j=2,4
            akapd(i,j)=akapd(i,1)
            ag(i,j)=ag(i,1)
            arlam(i,j)=arlam(i,1)
            apl(i,j)=apl(i,1)
         enddo
         i = i + 1
         goto 050
 500     nlam = i-1
      
         close(55)


      endif

c      print*,'ag',ag
c      print*,'akapd',akapd
      
      return
      end
